--- ltmain.sh	2003-09-24 19:48:39.367370072 +0200
+++ ltmain.sh	2003-09-24 19:49:31.773403144 +0200
@@ -1593,6 +1593,8 @@
 	    convenience="$convenience $ladir/$objdir/$old_library"
 	    old_convenience="$old_convenience $ladir/$objdir/$old_library"
 	    tmp_libs=
+	    # PKGW 
+	    dependency_libs=
 	    for deplib in $dependency_libs; do
 	      deplibs="$deplib $deplibs"
               if test "X$duplicate_deps" = "Xyes" ; then
@@ -1710,6 +1712,8 @@
 	  fi
 
 	  tmp_libs=
+	  #PKGW
+	  dependency_libs=
 	  for deplib in $dependency_libs; do
 	    case $deplib in
 	    -L*) newlib_search_path="$newlib_search_path "`$echo "X$deplib" | $Xsed -e 's/^-L//'`;; ### testsuite: skip nested quoting test
@@ -1871,6 +1875,16 @@
 		add="$dir/$linklib"
 	      elif test "$hardcode_minus_L" = yes; then
 		add_dir="-L$dir"
+		# Try looking first in the location we're being installed to.
+		if test -n "$inst_prefix_dir"; then
+		  case "$libdir" in
+		    [\\/]*)
+		      # Add the install location to the beginning, minimising possiblilty
+		      # of linking to older version of the lib already installed.
+		      add_dir="-L$inst_prefix_dir$libdir $add_dir"
+		      ;;
+		  esac
+		fi
 		add="-l$name"
 	      elif test "$hardcode_shlibpath_var" = yes; then
 		add_shlibpath="$dir"
@@ -1938,11 +1952,13 @@
 	    else
 	      # We cannot seem to hardcode it, guess we'll fake it.
 	      # Try looking first in the location we're being installed to.
-	      add_dir=
+	      add_dir="-L$dir"
 	      if test -n "$inst_prefix_dir"; then
 		case "$libdir" in
 		[\\/]*)
-		  add_dir="-L$inst_prefix_dir$libdir"
+		  # Add the install location to the beginning, minimising possiblilty
+		  # of linking to older version of the lib already installed.
+		  add_dir="-L$inst_prefix_dir$libdir $add_dir"
 		  ;;
 		esac
 	      fi
@@ -2146,7 +2162,7 @@
 	    -L*)
 	      case " $tmp_libs " in
 	      *" $deplib "*) ;;
-	      *) tmp_libs="$tmp_libs $deplib" ;;
+	      *) tmp_libs="$deplib $tmp_libs" ;;
 	      esac
 	      ;;
 	    *) tmp_libs="$tmp_libs $deplib" ;;
